import sys
import re

field.<sqrt2>=QQ

# The size of \cH_6
dimension=741
print "The size of H_6 = %d" % dimension

print
################################################################################

print "loading matrices L^, B^, R^ and checking the positive definiteness... "
L_hat = load_matrix("L_hat")
B_hat = load_matrix("B_hat")
R_hat = load_matrix("R_hat")

if (L_hat.is_positive_definite()):
	print "  The matrix L^ is positive definite"
else:
	print "  Error, the matrix L^ is not  not positive definite!"
	sys.exit()	

if (B_hat.is_positive_definite()):
	print "  The matrix B^ is positive definite"
else:
	print "  Error, the matrix B^ is not  not positive definite!"
	sys.exit()	

if (R_hat.is_positive_definite()):
	print "  The matrix R^ is positive definite"
else:
	print "  Error, the matrix R^ is not  not positive definite!"
	sys.exit()	


print "loading matrices M_lambda, M_beta, M_rho and computing the matrices L, B and R... "
M = {}
for sigma in ['lambda', 'beta', 'rho']:
	M[sigma] = load_matrix("M_%s" % sigma)

L = M['lambda'].transpose() * L_hat * M['lambda']
B = M['beta'].transpose() * B_hat * M['beta']
R = M['rho'].transpose() * R_hat * M['rho']


print 'loading "180 * [[A^sigma x B^sigma]]_sigma" coefficients for Cauchy-Schwarz calculus in the algebra F_C5'
CS_tables={}
for sigma in ['lambda', 'beta', 'rho']:
	CS_tables[sigma]= load_CS_table('cs_%s' % sigma)

pair_density = {}
pair_density['lambda'] = [Matrix(field, L.nrows(), L.ncols()) for _ in xrange(dimension)]
for graph_id in xrange(dimension):
	for (x,y) in CS_tables['lambda'][graph_id].keys():
		pair_density['lambda'][graph_id][x,y]=CS_tables['lambda'][graph_id][x,y]
		pair_density['lambda'][graph_id][y,x]=CS_tables['lambda'][graph_id][x,y]

pair_density['beta'] = [Matrix(field, B.nrows(), B.ncols()) for _ in xrange(dimension)]
for graph_id in xrange(dimension):
	for (x,y) in CS_tables['beta'][graph_id].keys():
		pair_density['beta'][graph_id][x,y]=CS_tables['beta'][graph_id][x,y]
		pair_density['beta'][graph_id][y,x]=CS_tables['beta'][graph_id][x,y]

pair_density['rho'] = [Matrix(field, R.nrows(), R.ncols()) for _ in xrange(dimension)]
for graph_id in xrange(dimension):
	for (x,y) in CS_tables['rho'][graph_id].keys():
		pair_density['rho'][graph_id][x,y]=CS_tables['rho'][graph_id][x,y]
		pair_density['rho'][graph_id][y,x]=CS_tables['rho'][graph_id][x,y]


print
################################################################################


# The positive values a and b

print "Loading the coefficients 180 * indepset3 * (red-edge + blue-edge - non-edge)... "
indep3_times_halfdensity = load_vector("indep3_times_halfdensity")
a = 30903/26624
if (a>0):
	print "The value of the positive constant a is equal to %s" %str(a)
else:
	print "Error, the value of a is not positive!"
	sys.exit()


print "Loading the coefficients 180 * co-cherry * (red-edge + blue-edge - non-edge)... "
cocher_times_halfdensity = load_vector("cocher_times_halfdensity")
b = 120771/32768
if (b>0):
	print "The value of the positive constant b is equal to %s" %str(b)
else:
	print "Error, the value of a is not positive!"
	sys.exit()	


print
################################################################################

print "Loading the coefficients 180 * triangle * (9*red-edge - 4)... "
trg_times_rededgebound = load_vector("trg_times_rededgebound")


print
################################################################################


print "Now we compute the final inequality..."
nonnegative_ineq=a*indep3_times_halfdensity + b*cocher_times_halfdensity

for graph_id in xrange(dimension):
	nonnegative_ineq[graph_id] += dot_matrix(pair_density['lambda'][graph_id], L)
	nonnegative_ineq[graph_id] += dot_matrix(pair_density['beta'][graph_id], B)
	nonnegative_ineq[graph_id] += dot_matrix(pair_density['rho'][graph_id], R)
	

expression = trg_times_rededgebound - nonnegative_ineq 
for graph_id in xrange(dimension):
	if (expression[graph_id]==0):
		if (VERBOSE): print "  The 6-vertex graph with index %d is tight" % graph_id
	elif (expression[graph_id]<0):
		print "  The claimed identity cannot be proven; problem with the %d-th coordinate" % graph_id
		sys.exit()

print "The claimed identity has been successfully verified"

print
################################################################################


indP4_coord=load_vector("indP4-coordinates")
for graph_id in indP4_coord:
	if (expression[graph_id]==0):
		print "The established proof does not guarantee P4-freeness for extremal limit"
		sys.exit()
print "The established proof of the identity guarantees that any homomorphism from Hom+(F_C7,Real) with 4/9 red edges and 1/18 blue edges has no induced P4"
