from os import chdir

VERBOSE = False

def dot_matrix(A,B):
	val=0
	for i in xrange(A.nrows()):
		for j in xrange(A.ncols()):
			val+=A[i,j]*B[i,j]

	return val
#END: dot_matrix


def load_vector(filename):
	f=open(filename)
	fline=f.readline()[:-1]
	return vector(field, fline.split(','))
#END: load_vector
	

def load_matrix(filename):
	f=open(filename)

	mat=[]
	i=0

	while True: 
		fline=f.readline()[:-1]
		if (fline==''): break
		mat.append( map(field, fline.split(',')) )

	f.close()

	return matrix(field, mat)
#END: load_matrix


#load Cauchy-Schwarz tables for a type sigma
def load_CS_table(filename):
	f=open(filename)

	table=[]
	i=0

	while True: 
		fline=f.readline()[:-1]
		if (fline==''): break
		size=int(fline)
		item={}
		for j in xrange(size):
			fline=f.readline()[:-1]
			(A,B,value)=map(int,fline.split())
			item[(A,B)]=value
		table.append(item)
		i+=size

	f.close()

	return table
#END: load_CS_table


print("Proof of Claim A.1")
chdir("claimA1_files")
load("verify_claim.sage")
chdir("..")

print("\n\n\n")

print("Proof of Claim B.1")
chdir("claimB1_files")
load("verify_claim.sage")
chdir("..")
